declare type CompareFunction<T> = (a: T, b: T) => -1 | 0 | 1;
interface Comparer<T> {
    compare: CompareFunction<T>;
    inf: (a: T, b: T) => boolean;
    sup: (a: T, b: T) => boolean;
    equal: (a: T, b: T) => boolean;
    infOrEqual: (a: T, b: T) => boolean;
    supOrEqual: (a: T, b: T) => boolean;
    setCompareFunction: (compareFunction: CompareFunction<T>) => any;
}
declare function compare<T>(a: T, b: T): -1 | 0 | 1;
declare function equal<T>(this: any, a: T, b: T): boolean;
declare function inf<T>(this: any, a: T, b: T): boolean;
declare function sup<T>(this: any, a: T, b: T): boolean;
declare function infOrEqual<T>(this: any, a: T, b: T): boolean;
declare function supOrEqual<T>(this: any, a: T, b: T): boolean;
declare const compareMethods: {
    compare: typeof compare;
    inf: typeof inf;
    sup: typeof sup;
    equal: typeof equal;
    infOrEqual: typeof infOrEqual;
    supOrEqual: typeof supOrEqual;
};
export type { Comparer, CompareFunction, };
export { compareMethods, };
