import type { Comparer, CompareFunction } from '../_shared';
declare class BinaryHeap<T> implements Comparer<T> {
    private values;
    compare: CompareFunction<T>;
    inf: <T_1>(this: any, a: T_1, b: T_1) => boolean;
    sup: <T_1>(this: any, a: T_1, b: T_1) => boolean;
    equal: <T_1>(this: any, a: T_1, b: T_1) => boolean;
    infOrEqual: <T_1>(this: any, a: T_1, b: T_1) => boolean;
    supOrEqual: <T_1>(this: any, a: T_1, b: T_1) => boolean;
    setCompareFunction(compareFunction: CompareFunction<T>): BinaryHeap<T>;
    get length(): number;
    toArray(): T[];
    insert(...values: T[]): T;
    shift(): T | undefined;
    clear(): void;
    private bubbleUp;
    private bubbleDown;
    private swap;
    private hasIndex;
}
export default BinaryHeap;
