import { CappedStructure } from '../_shared';
import { BinaryHeap } from '../heap';
declare class PriorityQueueNode<T> {
    value: T;
    priority: number;
    constructor(value: T, priority: number);
}
declare class PriorityQueue<T> implements CappedStructure {
    values: BinaryHeap<PriorityQueueNode<T>>;
    capacity: number;
    constructor(capacity?: number);
    get length(): number;
    enqueue(value: T, priority: number): PriorityQueueNode<T> | undefined;
    dequeue(): PriorityQueueNode<T> | undefined;
}
export default PriorityQueue;
