var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { guardOverflow, } from '../_shared';
import { BinaryHeap } from '../heap';
class PriorityQueueNode {
    constructor(value, priority) {
        this.value = value;
        this.priority = priority;
    }
}
class PriorityQueue {
    constructor(capacity) {
        this.capacity = -1;
        const compareFunction = (a, b) => {
            return a.priority < b.priority ? 1 : a.priority > b.priority ? -1 : 0;
        };
        this.values = new BinaryHeap().setCompareFunction(compareFunction);
        if (capacity && capacity > 0)
            this.capacity = capacity;
    }
    get length() {
        return !this.values ? 0 : this.values.length;
    }
    enqueue(value, priority) {
        const node = new PriorityQueueNode(value, priority);
        return this.values.insert(node);
    }
    dequeue() {
        return this.values.shift();
    }
}
__decorate([
    guardOverflow(false, undefined),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Number]),
    __metadata("design:returntype", Object)
], PriorityQueue.prototype, "enqueue", null);
export default PriorityQueue;
//# sourceMappingURL=priority-queue.js.map